"""A Super PoP switch product type."""

from orchestrator.domain.base import SubscriptionModel
from orchestrator.types import SubscriptionLifecycle

from gso.products.product_blocks.super_pop_switch import (
    SuperPopSwitchBlock,
    SuperPopSwitchBlockInactive,
    SuperPopSwitchBlockProvisioning,
)


class SuperPopSwitchInactive(SubscriptionModel, is_base=True):
    """An inactive Super PoP switch."""

    super_pop_switch: SuperPopSwitchBlockInactive


class SuperPopSwitchProvisioning(SuperPopSwitchInactive, lifecycle=[SubscriptionLifecycle.PROVISIONING]):
    """A Super PoP switch that is being provisioned."""

    super_pop_switch: SuperPopSwitchBlockProvisioning


class SuperPopSwitch(SuperPopSwitchProvisioning, lifecycle=[SubscriptionLifecycle.ACTIVE]):
    """A Super PoP switch that is currently active."""

    super_pop_switch: SuperPopSwitchBlock
